.\" $NetBSD: pnpbios.4,v 1.11 2002/09/27 22:31:45 wiz Exp $
.\"
.\" Copyright (c) 1999-2002 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by Lennart Augustsson.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd September 27, 2002
.Dt PNPBIOS 4 i386
.Os
.Sh NAME
.Nm pnpbios
.Nd introduction to PnP BIOS support
.Sh SYNOPSIS
.Cd "pnpbios0 at mainbus?"
.Cd "XX*      at pnpbios0 index ?"
.Pp
.Cd options PNPBIOSVERBOSE
.Cd options PNPBIOSDEBUG
.Sh INTRODUCTION
.Nm
provides support for finding and attaching devices by
extracting information from the PnP BIOS of a machine.
.Sh SUPPORTED DEVICES
.Nx
includes the following
.Nm
drivers, sorted by driver name:
.Pp
.Bl -tag -width speaker -offset indent -compact
.It com
serial communications interface
.It ess
ESS Technology AudioDrive family audio device driver
.It fdc
floppy controller
.It joy
game controller
.It lpt
parallel port driver
.It npx
math coprocessor
.It pciide
PCI IDE controllers driver
.It pckbc
PC keyboard/mouse controller
.It sb
SoundBlaster family audio device driver
.It wss
Windows Sound System hardware driver
.It ym
Yamaha OPL3-SA3 sound driver
.El
.Sh SEE ALSO
.Xr com 4 ,
.Xr ess 4 ,
.Xr fdc 4 ,
.Xr intro 4 ,
.Xr isa 4 ,
.Xr joy 4 ,
.Xr lpt 4 ,
.Xr npx 4 ,
.Xr pci 4 ,
.Xr pciide 4 ,
.Xr pckbc 4 ,
.Xr sb 4 ,
.Xr wss 4 ,
.Xr ym 4
.Sh HISTORY
The
.Nm
driver
appeared in
.Nx 1.5 .
.Sh BUGS
The
.Nm
bus provides a different way to attach devices than the real buses
(e.g.,
.Xr isa 4 ) .
The reason to use
.Nm
instead of the real bus is that some machines have weird routings
of, e.g., interrupts.  The exact information about these things can
be found in the BIOS, which is why the
.Nm
bus has a better chance of succeeding with getting it right.
.Pp
Many older BIOS implementations do not support PnP,
and some newer ones do not follow the standards.
